﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=8.8
@EndOfDesignText@
'DraggableView class module
Sub Class_Globals
	Public lblView As Label
	Private lblBackGround As ColorDrawable
	
	Private ParentActivity As Activity
	Private ParentTitle As String

	Private downx, downy As Float
	Private ACTION_DOWN, ACTION_MOVE, ACTION_UP As Int 'ignore
	
	Private touchaction As Int
	Dim downwidth As Int
	Dim downheight As Int
	Dim upname As String ' shown when not being dragged
	Dim name As String 
	Dim viewtypelc As String
	Dim scale As Float = GetDeviceLayoutValues.Scale
	Dim downtime As Long
	Dim clickdelay As Int = 250
	Dim Removed As Boolean = False
	
	Private NORMALCOLOR As Int
	Private RESIZEHEIGHT As Int = 1
	Private RESIZEHEIGHTCOLOR As Int = Colors.Green
	Private RESIZEWIDTH As Int = 2
	Private RESIZEWIDTHCOLOR As Int = Colors.Red
	Public DEFAULTCOLOR As Int = 0xFFF0F8FF ' the B4A bal magic color indicating to use the default for a view
	
	Private MOVE As Int = 3
	Private MOVECOLOR As Int = 0xffffd700   'gold


	Type ViewInfo(ViewName As String, ViewType As String, HasText As Boolean, ViewText As String, _ 
	ViewParentName As String, ViewChildren As List, ViewGeneration As Int, ViewColor As Int) 
	
	Dim ViewsMap As Map ' Reference to Main.ViewsMap
	Dim ViewsNamesMap As Map ' Reference to Main.ViewsNameMap
	
	Public GridSize() As Int ' array so we can pass as a reference, this is a dip value not a pixel one
End Sub

Public Sub CreateViewInfo (ViewName As String, ViewType As String, HasText As Boolean, ViewText As String, ViewParentName As String, ViewChildren As List, ViewGeneration As Int) As ViewInfo
	Dim t1 As ViewInfo
	t1.Initialize
	t1.ViewName = ViewName
	t1.ViewType = ViewType
	t1.HasText = HasText
	t1.ViewText = ViewText
	t1.ViewParentName = ViewParentName
	t1.ViewChildren = ViewChildren
	t1.ViewGeneration = ViewGeneration
	t1.ViewColor = DEFAULTCOLOR
	Return t1
End Sub

Public Sub SetHasText(text As String)
	' this is used by LayoutUtilswhen reloading a layout and a SetText has been found for a view	
	Dim vi As ViewInfo = lblView.Tag
	vi.HasText = True
	vi.ViewText = text
	If text <> "" Then
		upname = text
		lblView.Text = text
	End If	
End Sub

Public Sub SetColor(layoutcolor As Int, designercolor As Int)
	' we separate the colour we want to see in the designer colour and the colour we pass to the layout
	' layout colour is only added to the saved layout if it is not the magic default colour
	' whereas in the designer we want to see either the designer default colour or the user set colour
	Dim vi As ViewInfo = lblView.Tag
	vi.ViewColor = layoutcolor
	NORMALCOLOR = designercolor
	lblView.Color = designercolor
End Sub

Sub Initialize(Activity As Activity, ViewMap As Map, ViewNamesMap As Map, grid() As Int, ViewName As String, ViewType As String, _ 
	HasText As Boolean, ViewText As String, viewsize() As Int, viewcolor As Int)
	ParentActivity = Activity
	
	lblView.Initialize("lblName")
	Dim lblinfo As ViewInfo
	Dim Children As List	
	Children.Initialize
	
	ACTION_DOWN = Activity.ACTION_DOWN
	ACTION_MOVE = Activity.ACTION_MOVE
	ACTION_UP = Activity.ACTION_UP
	ViewsMap = ViewMap
	ViewsNamesMap = ViewNamesMap
	GridSize = grid	
	NORMALCOLOR = viewcolor
	viewtypelc = ViewType.ToLowerCase
	ParentTitle = ParentActivity.Title	

	
	lblinfo = CreateViewInfo(ViewName, ViewType, HasText, ViewText, "", Children, 0)
	' establish text shown when not pressed, MenuItems show menu text, others the view name
	If ViewType.ToLowerCase = "menuitem" Then
		upname = ViewText
	Else
		If HasText And ViewText <> "" Then
				upname = ViewText			
			Else			
				upname = ViewName
		End If
	End If
	name = ViewName
	
	Dim borderwidth As Int = 0
	If Main.DrawBorders Then borderwidth = Main.BorderWidth
	lblView.Tag = lblinfo
	lblView.Text = upname
	lblView.Gravity = Gravity.CENTER_HORIZONTAL + Gravity.CENTER_VERTICAL
	lblBackGround.Initialize2(Colors.Transparent, 0, borderwidth, Colors.Black)
	lblView.Background = lblBackGround
	lblView.Color = viewcolor
	
	'why reflection instead of the regular Panel_Touch event?
	'because B4A Panel_Touch events go through the message loop and cause delays when dragging
	Dim r As Reflector
	r.Target = lblView
	r.SetOnTouchListener("lblName_Touched")		
	Activity.AddView(lblView, viewsize(0), viewsize(1),viewsize(2),viewsize(3))
End Sub

Private Sub lblName_Touched (o As Object, ACTION As Int, x As Float, y As Float, motion As Object) As Boolean
	If Removed Then Return True' ignore anything queued after removal
	If ACTION = ACTION_DOWN Then
		downx = x
		downy = y	
		downtime = DateTime.Now
		lblView.TextSize = lblView.TextSize - 2

		downheight = lblView.Height
		downwidth = lblView.Width
		
		touchaction = MOVE
		lblView.Color = MOVECOLOR
		lblView.BringToFront
		
		If downx > downwidth * 0.75 Then
				touchaction = RESIZEWIDTH
			lblView.Color = RESIZEWIDTHCOLOR
		Else if  downx < downwidth * 0.25 And viewtypelc <> "menuitem" Then
			touchaction = RESIZEHEIGHT
			lblView.Color = RESIZEHEIGHTCOLOR
		End If
		lblView.Text = GetRelativeCoords
		ParentActivity.Title = name & " : " & lblView.Text
	Else If ACTION = ACTION_UP Then
		 ParentActivity.Title = ParentTitle
		lblView.Color = NORMALCOLOR
		lblView.Text = upname
		lblView.TextSize = lblView.TextSize + 2
		If DateTime.Now < (downtime + clickdelay) Then
			If x < lblView.Width/2 Then
				lblName_ClickLeft
			Else
				lblName_ClickRight
			End If
		End If
	Else ' Move
		Dim movex As Float = x - downx ' pixels
		Dim movey As Float = y - downy ' pixels		

		Dim newleft As Int = MoveToGrid(lblView.Left + movex) ' pixels
		Dim newtop As Int = MoveToGrid(lblView.Top + movey)
		Dim newwidth As Int = MoveToGrid(downwidth + movex)
		Dim newheight As Int = MoveToGrid(downheight + movey)
		
		If newheight < 0 Then newheight = 0
		If newwidth < 0 Then newwidth = 0			
		
		If touchaction = MOVE Then
			Dim movedx As Int = newleft - lblView.Left
			Dim movedy As Int = newtop - lblView.Top 
			lblView.Left = newleft
			lblView.Top = newtop
			BringToFrontSelfThenChildren(Me, movedx, movedy, 0)
		
		else if touchaction = RESIZEWIDTH Then
			lblView.Width = newwidth
			BringToFrontSelfThenChildren(Me, 0, 0, 0)
		else if touchaction = RESIZEHEIGHT Then
			lblView.Height = newheight
			BringToFrontSelfThenChildren(Me, 0, 0, 0)
		End If
		lblView.Text = GetRelativeCoords
		ParentActivity.Title = name & " : " & lblView.Text
	End If
	If (lblView.Width < 5dip Or lblView.Height < 5dip) And Not(Removed) Then 
		Removed = True ' do this here as we seem to get some re-entrancy while we are removing things
		ParentActivity.Title = ParentTitle ' we won't see the Up Action
		' Now remove from any parent
		Dim thisvi As ViewInfo = lblView.Tag
		Dim parentname As String = thisvi.ViewParentName.ToLowerCase
		Dim thisname As String = thisvi.ViewName.ToLowerCase
		If parentname <> "" Then
			Dim parentdv As DraggableView = ViewsNamesMap.Get(parentname)
			Dim parentv As View = parentdv.lblView
			Dim parentvi As ViewInfo = parentv.Tag
			Dim children As List = parentvi.ViewChildren
			For i = 0 To children.Size - 1
				Dim childname As String = children.Get(i)
				If childname.ToLowerCase = thisname Then
					children.RemoveAt(i)
					Exit
				End If				
			Next
		End If
		RemoveChildrenThenSelf(Me, 0)
	End If
	Return True
End Sub

Sub GetRelativeCoords As String
	Dim vi As ViewInfo = lblView.Tag
	If vi.ViewParentName = "" Then
		Return PixelsToDip(lblView.Left) & "," & PixelsToDip(lblView.Top) & "," & PixelsToDip(lblView.Width) & "," & PixelsToDip(lblView.Height)
	Else
		Dim pdv As DraggableView = ViewsNamesMap.Get(vi.ViewParentName)
		Dim pv As View = pdv.lblView
		
		Return PixelsToDip(lblView.Left-pv.Left) & "," & PixelsToDip(lblView.Top - pv.Top) & "," & PixelsToDip(lblView.Width) & "," & PixelsToDip(lblView.Height)
	End If
End Sub

Sub RemoveChildrenThenSelf(dv As DraggableView, iteration As Int)
	' This should cope with deeper nesting than LayoutUtils can
	Dim v As View = dv.lblView
	Dim vi As ViewInfo = v.Tag
	Dim children As List = vi.ViewChildren
	
	If children.Size > 0 Then
		For Each child As String In children
			Dim childdv As DraggableView = ViewsNamesMap.Get(child)
			Dim childv As View = childdv.lblView
			RemoveChildrenThenSelf(childdv, iteration + 1)
			childv.RemoveView
		Next
	End If
	v.RemoveView
	ViewsMap.Remove(dv)
	ViewsNamesMap.Remove(vi.ViewName.ToLowerCase)
End Sub

Sub BringToFrontSelfThenChildren(dv As DraggableView, xmove As Int, ymove As Int, iteration As Int)
	' This should cope with deeper nesting than LayoutUtils can
	Dim v As View = dv.lblView
	Dim vi As ViewInfo = v.Tag
	Dim children As List = vi.ViewChildren
	If dv <> Me Then v.BringToFront ' we get odd effects if we do this in our Touch event 
	If children.Size > 0 Then
		For Each child As String In children
			Dim childdv As DraggableView = ViewsNamesMap.Get(child)
			Dim childv As View = childdv.lblView
			childv.Left = childv.Left + xmove
			childv.Top = childv.Top + ymove
			BringToFrontSelfThenChildren(childdv, xmove, ymove, iteration + 1)
		Next
	End If
End Sub

Sub MoveToGrid(coord As Float) As Int	
	Dim isnegative As Boolean = False
	If coord < 0 Then
		isnegative = True
		coord = 0 - coord
	End If
	Dim grid As Int = GridSize(0)
	Dim dips As Float = PixelsToDip(coord)
	dips = dips - (dips Mod grid)
	dips = dips * scale + 0.5
	If	isnegative = True Then
		dips = 0 - dips - 1 '  - 1 corrects rounding -ve numbers to int value
	End If
	Return dips
End Sub

Sub PixelsToDip(pixels As Int) As Int
	If pixels < 0 Then
		Return pixels / scale - 0.5		
	End If
		Return pixels / scale + 0.5
End Sub

Sub lblName_ClickLeft
	' This should cope with deeper nesting than LayoutUtils can
	Dim parentvi, thisvi As ViewInfo
	Dim thisdv, parentdv As DraggableView
	Dim parentv As View
	Dim parenttype, parentname, thisname,  oldparentname, oldparentnamelc As String
	thisvi = lblView.Tag
	If thisvi.ViewType.ToLowerCase = "menuitem" Then ' MenuItems don't have parents
		Return
	End If
	thisname = thisvi.ViewName.ToLowerCase
	oldparentname = thisvi.ViewParentName
	If oldparentname = "" Then oldparentname = "Activity"
	oldparentnamelc = thisvi.ViewParentName.ToLowerCase
	thisdv = ViewsNamesMap.Get(thisname.ToLowerCase)
	' Find any children, we don't allow children to be parents as it will cause circular references
	Dim allchildren As List
	allchildren.Initialize '
	GetChildren(thisdv, allchildren)
	Dim parents As List
	parents.Initialize
	If oldparentnamelc <> "" Then parents.Add("Activity")
	For Each dv As DraggableView In ViewsMap.Keys
		parentv = dv.lblView
		parentvi = parentv.Tag
		parentname = parentvi.ViewName.ToLowerCase
		parenttype = parentvi.ViewType.ToLowerCase
		' Exclude parents that would make a circular reference
		Dim IsChild As Boolean = False
		For Each bname As String In allchildren
			If bname.ToLowerCase = parentname Then
				IsChild = True
			End If
		Next
		If parenttype = "panel" And parentname <> thisname And parentname <> oldparentnamelc And Not(IsChild) Then
			parents.Add(parentvi.ViewName)
		End If
	Next
	If parents.Size = 0 Then
		MsgboxAsync(CRLF & "No available parents!", "New Parent (old is " & oldparentname & ")")
		Return
	End If
	InputListAsync(parents, "New Parent (now is " & oldparentname & ")", -1, True) 
	Wait For InputList_Result (Index As Int)
	If Index >= 0  Then
		' Remove child from old parent
		If oldparentnamelc <> "" Then
			Dim oldparentdv As DraggableView = ViewsNamesMap.Get(oldparentname.ToLowerCase)
			Dim oldparentv As View = oldparentdv.lblView
			Dim oldparentvi As ViewInfo = oldparentv.Tag
			Dim children As List = oldparentvi.ViewChildren
			For i = 0 To children.Size -1
				Dim child As String = children.Get(i)
				If child.ToLowerCase = thisname Then
					' we shouldn't remove from a collection when iterating but as we exit immediately we can do it here
					children.RemoveAt(i)
					Exit
				End If			
			Next
		End If	
		' Add to new parent	
		parentname = parents.Get(Index)		
		If parentname = "Activity" Then parentname = ""
		thisvi.ViewParentName = parentname
		thisvi.ViewGeneration = 0
		If parentname <> "" Then
			parentdv = ViewsNamesMap.Get(parentname.ToLowerCase)
			parentv = parentdv.lblView
			parentvi = parentv.Tag
			children = parentvi.ViewChildren
			children.Add(thisname)
			thisvi.ViewGeneration = parentvi.ViewGeneration + 1
		End If		
		
	End If	
End Sub

Sub GetChildren(dv As DraggableView, children As List)
	Dim v As View = dv.lblView
	Dim vi As ViewInfo = v.Tag
	Dim childlist As List = vi.ViewChildren
	children.AddAll(childlist)
	For Each aname As String In childlist
		Dim childdv As DraggableView = ViewsNamesMap.Get(aname.ToLowerCase)
		GetChildren(childdv, children)
	Next	
End Sub

Sub lblName_ClickRight
	Dim thisvi As ViewInfo = lblView.Tag
	If thisvi.HasText Then
		Dim ip As InputDialog
		ip.Input = thisvi.ViewText
		Dim inp As Object = ip.ShowAsync("Change View Text", "", "OK", "", "Cancel", Null, True)
		Wait For (inp) Dialog_Result(Result As Int)
		If Result == DialogResponse.POSITIVE Then
			SetHasText(ip.Input)
		End If		
	End If
	If thisvi.ViewType.ToLowerCase = "menuitem" Then Return
	Dim xui As XUI
	Dim dialog As B4XDialog	
	dialog.Initialize(ParentActivity)
	dialog.BackgroundColor = Colors.White
	dialog.ButtonsColor = Colors.White
	dialog.ButtonsTextColor = 0xff008080
	dialog.ButtonsOrder =  Array As Int(xui.DialogResponse_Negative, xui.DialogResponse_Cancel, xui.DialogResponse_Positive)
	dialog.BorderColor = Colors.Gray
	dialog.OverlayColor = 0x60000000
	Dim ct As B4XColorTemplate
	ct.Initialize
	ct.SelectedColor = thisvi.ViewColor	
	Wait For (dialog.ShowTemplate(ct, "OK", "LAST", "CANCEL")) Complete (Result As Int)
	If Result = xui.DialogResponse_Positive Then ' OK
		If ct.SelectedColor = DEFAULTCOLOR Then
			' see the comment in SetColor
			SetColor(DEFAULTCOLOR, Main.ViewColorsMap.Get(thisvi.viewtype.ToLowerCase))
		Else
			SetColor(ct.SelectedColor, ct.SelectedColor)
		End If
		Main.LastColor = ct.SelectedColor
	else If Result = xui.DialogResponse_Negative Then ' LAST
		If Main.LastColor = DEFAULTCOLOR Then
			' see the comment in SetColor
			SetColor(DEFAULTCOLOR, Main.ViewColorsMap.Get(thisvi.viewtype.ToLowerCase))			
		Else
			SetColor(Main.LastColor, Main.LastColor)
		End If
	End If
End Sub
