﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=10
@EndOfDesignText@
Sub Class_Globals
	
	Dim SavedWidthDips As Int 'The width in dips of the layout being reloaded
	Dim	WidthPixels As Int 'The width in pixels of the present device

	Dim LastDv As DraggableView ' the last DraggableView, assumed to be the target of a setText(..) which always folllows addXXX
	Dim MenuCount As Int ' number of menu items read from layout file
	
	Type MenuItem (Top As Int, Text As String)
	
	Dim Indent As String = "  "
	
End Sub

'Initializes the object. You can add parameters to this method if needed.
Public Sub Initialize(WidthInPixels As Int)
	WidthPixels = WidthInPixels
End Sub

Sub GenerateGlobals(ViewsMap As Map) As String
	Dim defs As StringBuilder
	defs.Initialize
	defs.Append("REM Auto-generated global variables containing view names").Append(CRLF)
	defs.Append("activity = ''").Append(CRLF)
	Dim Vi As ViewInfo
	Dim v As View
	For Each dv As DraggableView In ViewsMap.Keys
		v = dv.lblView
		Vi = v.Tag
		If Vi.ViewType.ToLowerCase <> "menuitem" Then
			defs.Append(Vi.ViewName.ToLowerCase & " = StrToLower('" & Vi.ViewName & "')").Append(CRLF)
		End If
	Next
	defs.Append("g_width = 0").Append(CRLF)
	defs.Append("g_height = 0").Append(CRLF)
	defs.Append("g_scale = 0").Append(CRLF)
	defs.Append("REM End of auto-generated global variables").Append(CRLF)
	Return defs.ToString
End Sub

Sub GenerateLayout(ViewsMap As Map, CurrentWidth As Int, DeviceScale As Float, ViewsNameMap As Map) As String
	Dim Layout As StringBuilder
	Layout.Initialize
	Layout.Append("REM Auto-generated Sub LoadLayout").Append(CRLF)
	Layout.Append("Sub LoadLayout").Append(CRLF)
	Layout.Append(Indent & "REM Scale Controls To the activity width").Append(CRLF)
	Layout.Append(Indent & "REM Note that fonts are scaled according to screen Density by Android").Append(CRLF)
	Layout.Append(Indent & "g_width = getwidth('activity')").Append(CRLF)
	Layout.Append(Indent & "g_height = getheight('activity')").Append(CRLF)
	Layout.Append(Indent & "g_scale = g_width / " & NumberFormat(CurrentWidth/DeviceScale, 1, 0)).Append(CRLF)
	Layout.Append("").Append(CRLF)
	
	Dim parentleft, parenttop, viewgeneration, viewcolor, viewsadded As Int
	Dim vi As ViewInfo
	Dim v As View
	Dim viewname, viewtype, viewtext, viewparent, addcode, a, l, t, w, h, p As String
	viewsadded = 0
	' first we find how many menu items and mark them added so loop end test works
	For Each dv As DraggableView In ViewsMap.Keys
		v = dv.lblView
		vi = v.Tag
		If vi.ViewType.ToLowerCase = "menuitem" Then
			viewsadded = viewsadded + 1
		End If
	Next

	For i = 0 To 20 ' arbitrarily large value to exceed what we will ever see in practice
		Layout.Append(Indent & "REM Generation " & i & " views").Append(CRLF)
		For Each dv As DraggableView In ViewsMap.Keys
			v = dv.lblView
			vi = v.Tag
			viewtype = vi.ViewType
			viewname = vi.ViewName
			viewtext = vi.ViewText
			viewparent = vi.ViewParentName
			viewgeneration = vi.ViewGeneration
			viewcolor = vi.ViewColor
			If viewtype.ToLowerCase <> "menuitem" And viewgeneration = i Then
				parentleft = 0
				parenttop = 0
				' need to adjust a child view's left and top to be parent relative
				If viewparent <> "" Then
					Dim parentdv  As DraggableView = ViewsNameMap.Get(viewparent.ToLowerCase)
					Dim parentv As View = parentdv.lblView
					parentleft = parentv.Left
					parenttop = parentv.Top					
				End If
				a = "  add" & viewtype & "('" & viewname & "', "
				l = NumberFormat2((v.Left - parentleft) / DeviceScale, 1, 0, 0, False) & " * g_scale, "
				t = NumberFormat2((v.Top - parenttop) / DeviceScale, 1, 0, 0, False) & " * g_scale, "
				w = NumberFormat2(v.Width / DeviceScale, 1, 0, 0, False) & " * g_scale, "
				h = NumberFormat2(v.Height / DeviceScale, 1, 0, 0, False) & " * g_scale, "
				p = "'" & viewparent & "')"
				addcode = a & l & t & w & h	& p
				Layout.Append(addcode).Append(CRLF)
				viewsadded = viewsadded + 1
				If vi.HasText Then
					Layout.Append("  setText('" & viewname & "', '" & viewtext & "')" & CRLF)
				End If
				If viewcolor <> dv.DEFAULTCOLOR Then
					Layout.Append("  setColor('" & viewname & "', 0, " & viewcolor & ")" & CRLF)
				End If
				If vi.ViewType.ToLowerCase = "togglebutton" Then
					Layout.Append("  setChecked('" & viewname & "', False)" & CRLF)
				End If
			End If
		Next
		If viewsadded = ViewsMap.Size Then Exit
	Next
	' finally add the menu items in the same vertical order as displayed
	Layout.Append(Indent & "REM Menu items").Append(CRLF)
	Layout.Append(ReOrderMenuItems(ViewsMap))
	Layout.Append("End Sub").Append(CRLF)
	Return Layout.ToString
End Sub

Sub ReOrderMenuItems(ViewsMap As Map)  As String
	' order menuitems in layout according to top value
	' use the ability of list to sort on an item in a custom Type.
	Dim Layout As StringBuilder
	Dim vi As ViewInfo
	Dim v As View
	Dim ItemList As List
	Dim viewtype, viewtext, addcode As String
	Layout.Initialize
	ItemList.Initialize
	For Each dv As DraggableView In ViewsMap.Keys
		v = dv.lblView
		vi = v.Tag
		viewtype = vi.ViewType
		viewtext = vi.ViewText
		If (viewtype.ToLowerCase = "menuitem")Then
			Dim Item As MenuItem
			Item.Top = v.Top
			Item.Text = viewtext
			ItemList.Add(Item)
		End If
	Next
	ItemList.SortType("Top", True)	
	For Each mnu As MenuItem In ItemList
		addcode = "  addMenuItem('" & mnu.Text & "')"
		Layout.Append(addcode).Append(CRLF)
	Next
	Return Layout.ToString	
End Sub


Sub ReloadLayoutLine(Activity As Activity, ViewsMap As Map, ViewsNameMap As Map, GridSize() As Int, ViewSizesMap As Map, ViewColorsMap As Map, line As String)
	Dim dv As DraggableView
	Dim v As View
	Dim vi As ViewInfo
	Dim  viewname, viewtype, viewtext, viewparent As String
	Dim viewhastext As Boolean
	Dim left, top, width, height, parentleft, parenttop As Int
	Dim viewcolor, idx1, idx2 As Int
	
	line = line.Trim	
	If line.IndexOf("g_scale = g_width") = 0 Then
		' find the original dip scaling width		
		Dim Matcher1 As Matcher
		Matcher1 = Regex.Matcher("\d+", line) 'one or more digits
		Matcher1.Find
		SavedWidthDips = Matcher1.Match
		MenuCount = 0 ' convenient once only place to do this		
		
	else If line.IndexOf("setText('") = 0 Then
		' this is the text for the preceding DraggableView		
		idx1 = line.IndexOf("'")
		idx2 = line.IndexOf2("'", idx1+1)		
		viewname = line.SubString2(idx1+1, idx2)
		' find viewtext
		idx1 = line.IndexOf2("'", idx2+1)
		idx2 = line.IndexOf2("'", idx1+1)
		viewtext = line.SubString2(idx1+1, idx2)
		LastDv.SetHasText(viewtext)
		
	else If line.IndexOf("setColor('") = 0 Then
		' this is the color for the preceding DraggableView
		idx1 = line.IndexOf("'")
		idx2 = line.IndexOf2("'", idx1+1)
		viewname = line.SubString2(idx1+1, idx2)
		' find color
		idx1 = line.LastIndexOf(",")
		idx2 = line.LastIndexOf(")")
		viewcolor = line.SubString2(idx1+1, idx2).Trim
		LastDv.SetColor(viewcolor, viewcolor)
		
	else If line.IndexOf("add") = 0 Then
		' we are adding a view
		Matcher1 = Regex.Matcher("\d+", line) 'one or more digits
		' find viewtype
		idx1 = 3
		idx2 = line.IndexOf2("(", idx1)
		viewtype = line.SubString2(idx1, idx2)
		' find viewname or menu text if addMenuItem
		idx1 = line.IndexOf2("'", idx2+1)
		idx2 = line.IndexOf2("'", idx1+1)
		viewname = line.SubString2(idx1+1, idx2)
		' find co-ordinates
		If viewtype.ToLowerCase = "menuitem" Then
			' unlike other views we want the menu items same size when we rescale so we pre-undo the later scaling here			
			left = (100%x - 140dip) * SavedWidthDips / WidthPixels
			top =  MenuCount * (20dip * SavedWidthDips / WidthPixels)
			width =  140dip * SavedWidthDips / WidthPixels
			height =  20dip * SavedWidthDips / WidthPixels
			viewtext = viewname
			Main.MenuItemCount = Main.MenuItemCount + 1
			viewname = "MenuItem" & Main.MenuItemCount
			viewhastext = True
			viewparent = ""	
			MenuCount = MenuCount + 1
		Else
			Dim coords As List
			coords.Initialize
			line = line.SubString(idx2) ' view name might contain numbers
			Matcher1 = Regex.Matcher("\d+", line) 'one or more digits		
			Do While Matcher1.Find
				coords.Add(Matcher1.Match)
			Loop		
			' find parent
			idx1 = line.IndexOf2("'", idx2+1)
			idx2 = line.IndexOf2("'", idx1+1)
			viewparent = line.SubString2(idx1+1, idx2)			 
			left = coords.Get(0)
			top =  coords.Get(1)
			width =  coords.Get(2)
			height =  coords.Get(3)			
			viewtext = ""
			viewhastext = False		
		End If
		
		' check view type is valid
		If  ViewColorsMap.Get(viewtype.ToLowerCase) = Null Then
			ToastMessageShow("Invalid view type " & viewtype, True)
			Return
		End If
		' TODO Check if name exists
		' create draggableview and add to activity
		Dim olddv As DraggableView = ViewsNameMap.Get(viewname.ToLowerCase)
		If olddv <> Null Then
			ToastMessageShow("Duplicate view : " & viewname & " in layout", True)
			Return
		End If
		dv.Initialize(Activity, ViewsMap, ViewsNameMap, GridSize, viewname, viewtype, viewhastext, viewtext, _
			ViewSizesMap.Get(viewtype.ToLowerCase), ViewColorsMap.Get(viewtype.ToLowerCase))
		v = dv.lblView
		vi = v.Tag
		vi.ViewParentName = viewparent		
		
		' now we have the view we need to reposition it it relative to any parent unless it's a menu
		parentleft = 0
		parenttop = 0
		If viewtype.ToLowerCase <> "menuitem" And viewparent <> "" Then
			Dim parentdv  As DraggableView = ViewsNameMap.Get(viewparent.ToLowerCase)
			If parentdv = Null Then
				' this should never happen with a layout saved from the Designer
				Dim msg As String = ("Parent " & viewparent & " not found. View " & viewname & " added without parent.")		
				MsgboxAsync(msg, "Missing Parent")	
				'Wait For Msgbox_Result (Result As Int)
			Else	
				Dim parentv As View = parentdv.lblView
				parentleft = parentv.Left
				parenttop = parentv.Top
				Dim parentvi As ViewInfo = parentv.Tag			
				vi.ViewGeneration = parentvi.ViewGeneration + 1	
				parentvi.ViewChildren.Add(viewname)		
			End If			
		End If		
		
		' set the position on the activity of the view
		v.Left = parentleft + ((left / SavedWidthDips) * WidthPixels + 0.5)
		v.top = parenttop + ((top / SavedWidthDips) * WidthPixels + 0.5)
		v.Width = (width / SavedWidthDips) * WidthPixels + 0.5
		v.Height = (height / SavedWidthDips) * WidthPixels + 0.5
		vi.HasText = viewhastext
		vi.ViewText = viewtext		
		' finally save the view in ViewsMap and ViewsNameMap for future reference
		ViewsMap.Put(dv, viewname)
		ViewsNameMap.Put(viewname.ToLowerCase, dv)
		LastDv = dv
	End If
End Sub

